<%@ page import="com.ether.EtherPlotServiceImpl" %>
<script type="text/javascript">
var InterfaceVisualization = Class.create( {

    initialize: function( jsonPlateforms, axeTypesForFixedPlateforms, axeTypesForMobilePlateforms, firstDate, lastDate )
    {
        // Values
        this.parent = $( "#txt" );
        this.superParent = $( "#pageContent" ); // need to resize in function of containerParameters
        this.generalContainerPlateforms = $( "#generalContainerPlateforms" );
        this.generalContainerParameters = $( "#generalContainerParameters" );
        this.generalContainerOptions = $( "#generalContainerOptions" );
        this.jsonPlateforms = jsonPlateforms || null;
        this.jsonAxeTypesForFixedPlateforms = axeTypesForFixedPlateforms || null;
        this.jsonAxeTypesForMobilePlateforms = axeTypesForMobilePlateforms || null;
        this.firstDate = firstDate || false;
        this.lastDate = lastDate || false;
        this.selectedPlateform = false;
        this.selectedParameter = false;
        this.beginDate = false;
        this.endDate = false;
        this.numberParameterToDisplay = 0;

        /** *********** CONTAINERS *********** **/
        this.containerPlateforms = $( "#containerPlateforms" );
        this.containerParameters = $( "#containerParameters" );
        this.containerButtons = $( "#containerButtons" );
        this.containerOptionCalendar = $( "#containerOptionCalendar" );
        this.containerOptionType = $( "#containerOptionType" );
        this.containerOptionPlotsSelect = $( "#containerOptionPlotsSelect" );
        this.containerOptionPlotsButtons = $( "#containerOptionPlotsButtons" );

        /** *********** LOADING *********** **/
        // Create loading object for plateforms
        var param = new Object();
        param.id = "loadingForPlateforms";
        param.parent = this.containerPlateforms;
        this.loadingPlateforms = new Loading( param );
        this.loadingPlateforms.display();

        // Create loading object for parameters
        var param = new Object();
        param.id = "loadingForParameters";
        param.parent = this.containerParameters;
        this.loadingParameters = new Loading( param );
        this.loadingParameters.display();

        this.createOptions();
        this.displayPlateforms();
    },

    // CREATES ********************************************************
    createOptions: function()
    {
        // Calendar
        this.calendarFormat = "%Y-%m-%d %H:%i";
        this.calendarConverter = new AnyTime.Converter( { format: this.calendarFormat } );

        AnyTime.picker( "beginDate", { format: this.calendarFormat, firstDOW: 1,
            labelTitle: interfaceTexts["data.visualization.selectDate"], labelYear: interfaceTexts["data.visualization.selectYear"], labelMonth: interfaceTexts["data.visualization.selectMonth"], labelDayOfMonth: interfaceTexts["data.visualization.selectDay"],
            labelHour: interfaceTexts["data.visualization.selectHour"], labelMinute: interfaceTexts["data.visualization.selectMinute"],
            methodToCall: jQuery.proxy( this.onClickBeginDate, this )
        } );

        AnyTime.picker( "endDate", { format: this.calendarFormat, firstDOW: 1,
            labelTitle: interfaceTexts["data.visualization.selectDate"], labelYear: interfaceTexts["data.visualization.selectYear"], labelMonth: interfaceTexts["data.visualization.selectMonth"], labelDayOfMonth: interfaceTexts["data.visualization.selectDay"],
            labelHour: interfaceTexts["data.visualization.selectHour"], labelMinute: interfaceTexts["data.visualization.selectMinute"],
            methodToCall: jQuery.proxy( this.onClickEndDate, this ),
            idToUpdateEarliest: "beginDate"
        } );

        $( "#beginDate" ).val( this.firstDate );
        $( "#endDate" ).val( this.lastDate );
        this.clearCalendarButton = new Button( {value:interfaceTexts["data.visualization.button.clear"], parent:this.containerOptionCalendar, id:"button_clear_calendar", className:"small", onClick:jQuery.proxy( this.onClickClear, this )} );

        // Buttons and axe's types
        this.createButtons();
        this.createListTypes();
        this.createListPlots();
    },

    createButtons: function()
    {
        this.visualizeButton = new Button( {value:interfaceTexts["data.visualization.button.visualize"], parent:this.containerButtons, id:"button_visualize", onClick:jQuery.proxy( this.onClickVisualize, this )} );
        this.visualizeButton.disable();
        this.downloadButton = new Button( {value:interfaceTexts["data.visualization.button.download"], parent:this.containerButtons, id:"button_download", onClick:jQuery.proxy( this.onClickDownload, this )} );
        this.downloadButton.disable();
    },

    createListTypes: function()
    {
        var paramSelect = new Object();
        paramSelect.id = "select_axes";
        paramSelect.parent = this.containerOptionType;
        this.selectAxes = new Select( paramSelect );
    },

    createListPlots: function()
    {
        var paramSelect = new Object();
        paramSelect.id = "select_plots";
        paramSelect.parent = this.containerOptionPlotsSelect;
        paramSelect.classNameOption = "select_plot_option";
        this.selectPlots = new Select( paramSelect );
        this.selectParameters = $();
        this.selectPlots.add( null, interfaceTexts["data.visualization.graph.noPlot"] );
        this.selectPlots.selectFirst( false );

        this.selectPlotsPlateformType = false;

        this.addPlotButton = new Button( {value:interfaceTexts["data.visualization.add"], parent:this.containerOptionPlotsButtons, id:"button_add_plot", className:"small", onClick:jQuery.proxy( this.onClickAddPlot, this )} );
        this.addPlotButton.disable();
        this.initPlotButton = new Button( {value:interfaceTexts["data.visualization.button.init"], parent:this.containerOptionPlotsButtons, id:"button_init_plot", className:"small", onClick:jQuery.proxy( this.onClickInitPlot, this )} );
    },

    // REQUESTS ********************************************************
    requestParametersByPlateform: function()
    {
        if( this.selectedPlateform )
            $.ajax( {
                url: "visualization?methodName=searchParametersByPlateform&id=" + this.selectedPlateform.getId(),
                success:jQuery.proxy( this.handleParametersBySelectedPlateform, this )
            } );
    },

    requestDownload: function()
    {
        var urlObject = this.createUrl();
        $.ajax( {
            url: "visualization?methodName=downloadData&" + urlObject.parameters,
            success:jQuery.proxy( this.handleDownload, this )
        } );
    },

    // HANDLES ********************************************************
    handleParametersBySelectedPlateform: function( result )
    {
        this.jsonParameters = jQuery.parseJSON( result ).parameters;
        this.displayParameters();
    },

    handleDownload: function( result )
    {
        var stateResult = result.responseText.evalJSON().result;

        var downloadWindow = new Window( {className: "dialog", zIndex: 100, resizable: true, draggable:true, wiredDrag: true, showEffect:Effect.BlindDown, hideEffect: Effect.SwitchOff } );
        downloadWindow.setTitle( interfaceTexts["data.access.extract3"] );
        if( stateResult == "ok" )
        {
            downloadWindow.getContent().innerHTML = '<div class="textExamplesTD">' + interfaceTexts["data.access.extract.process.short"] + '</div>';
            downloadWindow.setSize( 350, 50 );
        }
        else
        {
            downloadWindow.getContent().innerHTML = '<div class="textExamplesTD">' + interfaceTexts["data.access.extract.process.error"] + '</div>';
            downloadWindow.setSize( 350, 60 );
        }
        downloadWindow.show();
    },

    // DISPLAYS ********************************************************
    displayPlateforms: function()
    {
        this.plateforms = new ListPlatforms( this.jsonPlateforms, new Object() );

        this.plateforms.addOpenListener( jQuery.proxy( this.onSelectPlateform, this ) );
        this.loadingPlateforms.hide();
        this.plateforms.display( this.containerPlateforms, "NoPlateform", interfaceTexts["data.visualization.noPlateform"] );

        // Select the first plateform by default
        if( this.jsonPlateforms && this.jsonPlateforms[0] )
        {
            var plateformToSelect = this.plateforms.getItemById( this.jsonPlateforms[0].id );
            this.onSelectPlateform( plateformToSelect.divItem );
            this.selectedPlateform = plateformToSelect.divItem;
        }
    },

    displayParameters: function()
    {
        this.parameters = new ListParameters( this.jsonParameters, new Object() );

        this.parameters.addOpenListener( jQuery.proxy( this.onSelectParameter, this ) );
        this.loadingParameters.hide();
        this.parameters.display( this.containerParameters, "NoParameter", interfaceTexts["data.visualization.noParameter"], "containerParameter" );
    },

    // EVENTS ********************************************************
    onSelectPlateform: function( objPlateform )
    {
        if( this.selectedPlateform && objPlateform.getId() == this.selectedPlateform.getId() )
            return;

        // Unselect old plateform
        if( this.selectedPlateform )
            this.selectedPlateform.unselect();

        this.selectedPlateform = objPlateform;
        this.selectedPlateform.select();

        // Unselect old parameter
        if( this.selectedParameter )
            this.selectedParameter = false;

        // Change axe's list select
        this.updateListAxes();

        this.addPlotButton.disable();

        $( "#textareaTitle" ).html( this.selectedPlateform.getName() );

        // Init number and list of parameter to display
        if( "MOBILE" == this.selectedPlateform.jsonElement.type )
            this.updateNumberAndListParameterToDisplay( 0 );

        if( 1 > this.selectPlots.getSize() )
            this.numberParameterToDisplay = 0;

        this.requestParametersByPlateform();
        this.testAllFields();
    },

    onSelectParameter: function( objParameter )
    {
        if( this.selectedParameter && objParameter.getId() == this.selectedParameter.getId() )
            return;

        // Unselect old parameter
        if( this.selectedParameter )
            this.selectedParameter.unselect();

        this.selectedParameter = objParameter;
        this.selectedParameter.select();

        // Change title
        $( "#textareaTitle" ).html( this.selectedPlateform.getName() + " - " + this.selectedParameter.getName() );

        // Update number and list of parameter to display
        this.updateNumberAndListParameterToDisplay( 1 );

        // Enable/disable addPlot's button
        if( (!this.selectPlotsPlateformType || this.selectPlotsPlateformType == this.selectedPlateform.jsonElement.type) && "MOBILE" != this.selectedPlateform.jsonElement.type )
            this.addPlotButton.enable();
        else
            this.addPlotButton.disable();

        this.testAllFields();
    },

    onClickBeginDate: function()
    {
        var oneHour = 60 * 60 * 1000;
        var beginDateTime = this.calendarConverter.parse( $( "#beginDate" ).val() ).getTime();
        var endDateTime = null;
        if( "" != $( "#endDate" ).val() )
            endDateTime = this.calendarConverter.parse( $( "#endDate" ).val() ).getTime();
        this.beginDateWithAnHourLater = new Date( beginDateTime + oneHour );

        if( null == endDateTime || endDateTime < beginDateTime )
            $( "#endDate" ).val( this.calendarConverter.format( this.beginDateWithAnHourLater ) );

        this.beginDate = this.calendarConverter.parse( $( "#beginDate" ).val() ).getTime();
        this.endDate = this.calendarConverter.parse( $( "#endDate" ).val() ).getTime();

        this.testAllFields();
    },

    onClickEndDate: function()
    {
        this.endDate = this.calendarConverter.parse( $( "#endDate" ).val() ).getTime();
    },

    onClickClear: function()
    {
        $( "#beginDate" ).val( "" );
        this.beginDate = false;
        $( "#endDate" ).val( "" );
        this.endDate = false;
    },

    onClickInitPlot: function()
    {
        this.updateNumberAndListParameterToDisplay( 0 );
    },

    onClickAddPlot: function()
    {
        this.updateNumberAndListParameterToDisplay( 2 );
    },

    onClickVisualize: function()
    {
        var urlObject = this.createUrl();

        if( urlObject.displayPlot )
        {
            var url = "visualization/plotEther?" + urlObject.parameters;
            var $dialog = $( '<div></div>' )
                    .html( '<img src=' + url + ' />' )
                    .dialog( {
                                 autoOpen: false,
                                 title: interfaceTexts["app.title"] + "-" + interfaceTexts["data.visualization.quicklook"],
                                 minHeight: <%=EtherPlotServiceImpl.getMaxHeight()%>,
                                 minWidth: <%=EtherPlotServiceImpl.getMaxWidth()%> + 28
                             } );
        }
        else
        {
            var $dialog = $( '<div></div>' )
                    .html( '<BR/><center>' + interfaceTexts["data.visualization.graph.noPlot"] + '</center>' )
                    .dialog( {
                                 autoOpen: false,
                                 title: interfaceTexts["app.title"] + "-" + interfaceTexts["data.visualization.quicklook"],
                                 height: 50,
                                 width: 400
                             } );
        }

        $dialog.dialog( 'open' );
        return false;
    },

    onClickDownload: function()
    {
        if( !getJSONUser() )
        // Method showLogin writen in megapoliHead.jsp
            getLoginModule().showLogin( templateTexts["data.authentification.text"] );
        else
            this.requestDownload();
    },

    // OTHERS ********************************************************
    testAllFields: function()
    {
        if( (!this.selectedPlateform || !this.selectedParameter) && 0 == this.numberParameterToDisplay )
        {
            this.visualizeButton.disable();
            this.downloadButton.disable();
            return;
        }

        this.visualizeButton.enable();
        this.downloadButton.enable();
    },

    updateListAxes: function()
    {
        this.selectAxes.clear();
        var jsonAxeTypes;

        if( "MOBILE" == this.selectedPlateform.jsonElement.type )
            jsonAxeTypes = this.jsonAxeTypesForMobilePlateforms;
        else
            jsonAxeTypes = this.jsonAxeTypesForFixedPlateforms;

        jQuery.each( jsonAxeTypes, jQuery.proxy( function ( i, axeType )
        {
            this.selectAxes.add( axeType.value, interfaceTexts[axeType.text] );
        }, this ) );

        this.selectAxes.selectFirst( false );
    },

    /**
     * action = 0 --> init list
     * action = 1 --> select parameter
     * action = 2 --> add parameter
     */
    updateNumberAndListParameterToDisplay: function( action )
    {
        switch( action )
        {
            case 0:
                // INIT
                this.selectPlots.clear();
                this.selectParameters.empty();
                this.selectPlotsPlateformType = false;

                if( this.selectedPlateform && this.selectedParameter )
                {
                    this.selectPlots.changeSelectMiddle( this.selectedPlateform.getId() + "-" + this.selectedParameter.getId(), this.selectedPlateform.getName() + " - " + this.selectedParameter.getName() );

                    this.numberParameterToDisplay = 1;
                    $( "#messages_number_parameters" ).html( this.numberParameterToDisplay + " " + interfaceTexts["data.visualization.parameter"] );
                }
                else
                {
                    this.selectPlots.add( null, interfaceTexts["data.visualization.graph.noPlot"] );
                    this.selectPlots.selectFirst( false );

                    this.numberParameterToDisplay = 0;
                    $( "#messages_number_parameters" ).html( "" );
                }
                break;

            case 1 :
                // SELECT
                if( 0 == this.numberParameterToDisplay || "MOBILE" == this.selectedPlateform.jsonElement.type )
                {
                    this.selectPlots.clear();
                    this.selectParameters.empty();
                    this.numberParameterToDisplay = 1;
                }

                this.selectPlots.changeSelectMiddle( this.selectedPlateform.getId() + "-" + this.selectedParameter.getId(), this.selectedPlateform.getName() + " - " + this.selectedParameter.getName() );
                $( "#messages_number_parameters" ).html( this.numberParameterToDisplay + " " + interfaceTexts["data.visualization.parameter"] );
                break;

            default:
                // ADD
                var plotValue = this.selectedPlateform.getId() + "-" + this.selectedParameter.getId();
                var isParameterAlreadySelected = content( this.selectParameters, this.selectedParameter.getId() );
                if( !this.selectPlots.content( plotValue ) && (isParameterAlreadySelected || (!isParameterAlreadySelected && this.selectParameters.size() < 2)) )
                {
                    this.selectPlots.add( plotValue, this.selectedPlateform.getName() + " - " + this.selectedParameter.getName() );
                    this.selectPlots.select( plotValue, false );
                    this.selectPlotsPlateformType = this.selectedPlateform.jsonElement.type;
//                    if( !isParameterAlreadySelected )
                    this.selectParameters.push( this.selectedParameter.getId() );

                    this.numberParameterToDisplay = this.selectPlots.getSize();
                }

                $( "#messages_number_parameters" ).html( this.numberParameterToDisplay + " " + interfaceTexts["data.visualization.parameter"] );
                break;
        }
    },

    createUrl : function()
    {
        // TODO : utiliser JSON pour envoyer arrayPIdPId
        var result = new Object();

        result.displayPlot = true;
        var arrayPIdPId = new Array();
        if( 1 <= this.numberParameterToDisplay && 1 <= this.selectPlots.getSize() )
        {
            var index = 0;
            this.selectPlots.arrayOptions.each( function( option )
            {
                arrayPIdPId[index] = option.itemValue;
                index++;
            } );
        }
        else if( this.selectedPlateform && this.selectedParameter )
            arrayPIdPId[0] = this.selectedPlateform.getId() + "-" + this.selectedParameter.getId();
        else
            result.displayPlot = false;

        result.parameters = "dateBegin=" + this.beginDate
                + "&dateEnd=" + this.endDate
                + "&title=" + encodeURIComponent( $( "#textareaTitle" ).val() )
                + "&pfIdPIdList=" + arrayPIdPId
                + "&axeType=" + this.selectAxes.getValue();

        return result;
    }
} );

function onClickHelp()
{
    var helpWindow = new Window( {className: "dialog", zIndex: 100, resizable: true, draggable:true, wiredDrag: true, showEffect:Effect.BlindDown, hideEffect: Effect.SwitchOff } );
    helpWindow.setTitle( interfaceTexts["data.visualization.parameter.buttons.help"] );
    helpWindow.getContent().innerHTML = '<div class="textExamplesTD">' + interfaceTexts["data.visualization.parameter.buttons.help.text"] + '</div>';
    helpWindow.setSize( 350, 100 );
    helpWindow.show();
}


</script>